//+------------------------------------------------------------------+
//|                                                        Click.mqh |
//|                        Copyright 2017, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2017, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property strict
#include <Controls\Dialog.mqh>
#include <Controls\Button.mqh>
#include <Controls\ListView.mqh>
//+------------------------------------------------------------------+
//| Class Scenario  PANEL                                            |
//+------------------------------------------------------------------+
class CPanelDialog : public CAppDialog{
   private:
      CButton    m_butt_rec;                       
      CButton    m_butt_refr;                   
      CButton    m_butt_go;                    
      CListView  m_list_view;                     
   public:
      virtual bool      Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2);
      virtual bool      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
      
   protected:
      
      bool           CreateButtonRec (int x1, int y1, int x2, int y2);
      bool           CreateButtonRefr(int x1, int y1, int x2, int y2);
      bool           CreateButtonGo  (int x1, int y1, int x2, int y2);
      bool           CreateListView  (int x1, int y1, int x2, int y2);
      void           Minimize(void); 
      void           OnClickButton1(void);
      void           OnClickButton2(void);
      void           OnClickButton3(void);};
//+------------------------------------------------------------------+
//| Event Handling                                                   |
//+------------------------------------------------------------------+
EVENT_MAP_BEGIN(CPanelDialog)
   ON_EVENT(ON_CLICK, m_butt_rec,  OnClickButton1)
   ON_EVENT(ON_CLICK, m_butt_refr, OnClickButton2)
   ON_EVENT(ON_CLICK, m_butt_go,   OnClickButton3)
EVENT_MAP_END(CAppDialog)
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool CPanelDialog::Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2){
   if(!CAppDialog::Create(chart,name,subwin,x1,y1,x2,y2)) return(false);
   int by1 = 0;
   int bx1 = 0; 
   int bh  = 15;
   int bw  = (int)MathFloor(ClientAreaWidth()/3)-by1*2;
   int lx2 = bw*3; 
   int ly2 = ClientAreaHeight()-by1; 
   
   if(!CreateButtonRec  (bx1+bw*0, by1,    bx1+bw*1,  by1+  bh))  return(false);
   if(!CreateButtonRefr (bx1+bw*1, by1,    bx1+bw*2,  by1+  bh))  return(false);
   if(!CreateButtonGo   (bx1+bw*2, by1,    bx1+bw*3,  by1+  bh))  return(false);
   if(!CreateListView   (bx1+bw*0, by1+bh, bx1+bw*3,  ly2     ))  return(false);
   return(true);}
//+------------------------------------------------------------------+
void CPanelDialog::Minimize(void){
   CAppDialog::Minimize();
   CAppDialog::Move(2, 20); }
//+------------------------------------------------------------------+
bool CPanelDialog::CreateButtonRec(int x1, int y1, int x2, int y2){
   if(!this.m_butt_rec.Create(m_chart_id,m_name+"_Rec",m_subwin, x1, y1, x2, y2)) return(false);
   if(!m_butt_rec.Text("Rec")) return(false);
   if(!Add(m_butt_rec))return(false);
   //m_butt_rec.Alignment(WND_ALIGN_RIGHT,0,0,0,0);
   return(true);}
bool CPanelDialog::CreateButtonRefr(int x1, int y1, int x2, int y2){
   if(!this.m_butt_refr.Create(m_chart_id,m_name+"_Refr",m_subwin, x1, y1, x2, y2)) return(false);
   if(!m_butt_refr.Text("Refr")) return(false);
   if(!Add(m_butt_refr))return(false);
   //m_butt_refr.Alignment(WND_ALIGN_RIGHT,0,0,0,0);
   return(true);}
bool CPanelDialog::CreateButtonGo(int x1, int y1, int x2, int y2){
   if(!this.m_butt_go.Create(m_chart_id,m_name+"_Go",m_subwin, x1, y1, x2, y2)) return(false); 
   if(!m_butt_go.Text("Go")) return(false);
   if(!Add(m_butt_go))return(false);
   //m_butt_go.Alignment(WND_ALIGN_RIGHT,0,0,0,0);
   return(true);}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool CPanelDialog::CreateListView(int x1, int y1, int x2, int y2){
   if(!m_list_view.Create(m_chart_id,m_name+"ListView",m_subwin,x1,y1,x2,y2)) return(false);
   if(!Add(m_list_view)) return(false);
   //m_list_view.Alignment(WND_ALIGN_HEIGHT,0,0,0,0);
   
   for(int i=0;i<16;i++)  if(!m_list_view.ItemAdd("Item "+IntegerToString(i))) return(false);
   return(true);}

//+------------------------------------------------------------------+
//| Event handler                                                    |
//+------------------------------------------------------------------+
void CPanelDialog::OnClickButton1(void){ Alert(__FUNCTION__); }
void CPanelDialog::OnClickButton2(void){ Alert(__FUNCTION__); }
void CPanelDialog::OnClickButton3(void){ Alert(__FUNCTION__); }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+



  